



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Unit Tests Tool - &lt;What is “Mock You”&gt; The introduction to moq #Reprinted#</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Unit Tests Tool - &lt;What is “Mock You”&gt; The introduction to moq #Reprinted#</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 19:50:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>From: http://www.cnblogs.com/wJiang/archive/2010/02/21/1670632.html</p>
<hr />
<div>Moq即Mock You Framework,故名思意是一个类似Mockery，JMock的Mock框架。 是google上的一个.net开源项目</div>
<table>
<tbody>
<tr>
<td>项目扉页</td>
<td>相关下载</td>
</tr>
<tr>
<td><a href="http://code.google.com/p/moq/" rel="external nofollow noreferrer">http://code.google.com/p/moq/</a></td>
<td><a href="http://code.google.com/p/moq/downloads/list" rel="external nofollow noreferrer">http://code.google.com/p/moq/downloads/list</a></td>
</tr>
</tbody>
</table>
<p><strong>先说说一般的使用Mock进行测试的基本过程：</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images.cnblogs.com/cnblogs_com/wJiang/WindowsLiveWriter/Moq_81FB/image_thumb_1.png" /></p>
<p>Moq的3.x版本已经不同以往，这得益于.net3.x为大家带来的Lambda表达式，Linq。</p>
<p><strong>说说Moq的优点：</strong></p>
<p>a.完全开源。开源的好处我就不多说了，不过相比java社区上的活跃，Apache项目的浩繁，.net在这方面确实逊色不少。</p>
<p>b.简单易学，便于使用。Moq的设计原则就是&ldquo;以极低的门槛获取良好的重构能力&rdquo;在我个人看来，Moq是我用过的上手最容易使用起来最自然的Mock。</p>
<p><strong>Moq中几个重要的类（在后续文章中详细介绍）：</strong></p>
<p>Mock&lt;T&gt;：通过这个类我们能够得到一个Mock&lt;T&gt;对象，T可以是接口 和 类。它有一个公开的Object属性，这个就是我们Moq为我们模拟出的对象。</p>
<p>It：这是一个静态类，用于过滤参数。</p>
<p>MockBehavior：用于配置MockObject的行为，比如是否自动mock。</p>
<p>MockFactory：Mock对象工厂，能够批量生产统一自定义配置的Mock对象，也能批量的进行Mock对象测试。</p>
<p>Match&lt;T&gt;：如果你先嫌It不够用就用Match&lt;T&gt;，通过它能够完全自定义规则。</p>
<p><strong>初识Moq</strong>：</p>
<p>新建一个测试，我们用三行代码演示一个Moq的使用。</p>
<div>
<pre class="prettyprint linenums">[TestMethod()]<br />
[Owner(wJiang)]<br />
public void MoqTest0()<br />
        {<br />
            //make a Mock Object by Moq<br />
            var mo = new Mock&lt;TargetInterfaceOne&gt;(); 

            //Setup our Mock Object<br />
            mo.Setup(p =&gt; p.MethodWithParamAndResult("abc")).Returns("123"); 

            //Assert it!<br />
            Assert.AreEqual("123", mo.Object.MethodWithParamAndResult("abc"));<br />
        }
</pre>
</div>
<p>说明：</p>
<p>new Mock&lt;T&gt;返回一个Mock对象，我们可以用var接收，这样写起来更方便些，Mock&lt;T&gt;有一个Object属性，存储的就是我们的模拟对象实例。</p>
<p>Setup的参数是一个Lambda Expression，我们可以理解为：&ldquo;当 被mock的对象p调用MethodWithParamAndResult方法 并且参数为&rdquo;abc&rdquo;的时候&rdquo;。后面再加一个Return(&ldquo;123&rdquo;)我们可以理解为：（在之前Setup的情况下）返回的值为&rdquo;123&rdquo;。这样，我们就填充好了一个&ldquo;伪对象&rdquo;的行为，我们只让它做一件实事儿：当我们调用mo.Object.MethodWithParaAndResult方法并且参数为&rdquo;abc&rdquo;时会返回&rdquo;123&rdquo;。</p>
<p>实际上我们不仅能够在Setup后面接Returns方法还能接诸如Throws、Verify之类的方法，这是为什么呢？Setup方法会返回一个ISetup对象，看看ISetup的定义：</p>
<p>public interface ISetup&lt;TMock, TResult&gt; : ICallback&lt;TMock, TResult&gt;, IReturnsThrows&lt;TMock, TResult&gt;, IReturns&lt;TMock, TResult&gt;, IThrows, INever, IVerifies, IHideObjectMembers where TMock : class</p>
<p>恩，是链式编程，ISetup接口继承了很多接口，这里我们注意到IReturns&lt;TMock，TResult&gt;，看看IReturns&lt;TMock, TResult&gt;定义：</p>
<p>public interface IReturns&lt;TMock, TResult&gt; : IHideObjectMembers where TMock : class。</p>
<p>里面有一个方法:IReturnsResult&lt;TMock&gt; Returns&lt;T&gt;(Func&lt;T, TResult&gt; valueFunction);</p>
<p>所以我们还能写出这样的代码：</p>
<p>mo.Setup(p =&gt; p.MethodWithParamAndResult("abc"))</p>
<p>.Returns("123")</p>
<p>.Callback(&hellip;&hellip;)</p>
<p>.Throws(&hellip;&hellip;)</p>
<p>.Verifiable(&hellip;&hellip;);</p>
<p>呵呵，这种代码理解起来是很自然的。Moq设计的是不是很人性化呢。</p>
<hr />
<p>上一篇介绍了Moq并给出了一个入门的例子。下面说说Moq中的参数匹配。先看Mock&lt;T&gt;的一个方法。</p>
<p>public ISetup&lt;T&gt; Setup(Expression&lt;Action&lt;T&gt;&gt; expression);</p>
<p>熟悉.NET框架尤其是开发过基于MVVM的WPF应用程序的朋友对Action&lt;T&gt;和Prediect&lt;T&gt;这两个泛型委托应该不陌生，这两个委托的含义很简明，前者表示给定一个参数然后施展一个行为，后者表示施行行为的前提。</p>
<p>假如我们有一个接口IA，IA有一个方法签名string MethodA1(stringidentity)。那么我们怎么模拟一个实现IA接口的对象MethodA1呢？</p>
<div>
<pre class="prettyprint linenums">var mo = new Mock&lt;IA&gt;();<br />
mo.Setup( p =&gt; p.MethodA1(&ldquo;50&rdquo;)).Return(&ldquo;Hello, mocker&rdquo;);
</pre>
</div>
<p>这个例子和上一篇是一样的，这里在额外说明下:Return的参数类型取决于方法的返回类型,如果我们把MethodA1返回void,那么就没法Return方法了,这里由于返回string类型，所以能Return。</p>
<p>当然，方法参数可可选值很多，"51"，&rdquo;52&rdquo;，&rdquo;53&rdquo;，&rdquo;54&rdquo;，&rdquo;55&rdquo;，&rdquo;56&rdquo;&hellip;&hellip;如果我们一个一个的Setup怎么能行？我向大家隆重推出两个类：It,Match&lt;T&gt;。</p>
<p>先说It，It很适合用来匹配数字，字符串参数，它提供了如下几个静态方法(取自Moq的官方API文档):</p>
<p><img referrerpolicy="no-referrer"src="https://images.cnblogs.com/cnblogs_com/wJiang/WindowsLiveWriter/WhatisMockYouMoq_BFCA/image_thumb.png" /></p>
<p>第一个方法的参数Expression&lt;Predict&lt;TValue&gt;&gt;类型，当你需要某种类型并且这种类型要通过代码来判断的话可以使用它。</p>
<p>第二个方法没有参数，只要是TValue类型的就能匹配成功。</p>
<p>第三个方法用来匹配两个的TValue类型值之间的参数。（Range参数可以设定开闭区间）</p>
<p>第四个是用正则表达式匹配。（仅限于字符串类型参数）</p>
<p>举个例子：</p>
<div>
<pre class="prettyprint linenums">[TestMethod]<br />
[Owner(wJiang)]<br />
public void MoqTest1()<br />
{<br />
            var mo = new Mock&lt;TargetInterfaceOne&gt;();<br />
            mo.Setup(p =&gt; p.MethodWithParamAndResult(It.IsRegex("^God.*$"))).Returns("bless me");<br />
            mo.Setup(p =&gt; p.MethodWithParamAndResult(It.Is&lt;string&gt;((param =&gt; param.IndexOf("Evil") &gt;= 0)))).Returns("away from me");<br />
            //mo.Setup(p =&gt; p.MethodWithParamAndResult(It.):<br />
            Assert.AreEqual("bless me", mo.Object.MethodWithParamAndResult("God comes"));<br />
            Assert.AreEqual("away from me", mo.Object.MethodWithParamAndResult("Evil is here"));<br />
        }
</pre>
</div>
<p>但是It提供的功能还是显得有些弱，这时候我们可以自定义匹配验证规则。这就用到了Match&lt;T&gt;。</p>
<p>Match&lt;T&gt;是个静态类，它值公开了一个静态方法（重载了两个版本）：public static T Create(Predict&lt;T&gt; condition, &hellip;&hellip;)。</p>
<p>先看下下面的代码便于讲解，我们写个用于参数匹配的静态帮助类。</p>
<div>
<pre class="prettyprint linenums">[TestMethod()]<br />
        public void MoqTestA()<br />
        {<br />
            var mo = new Mock&lt;TargetInterfaceOne&gt;();<br />
            mo.Setup(p =&gt; p.MethodWithParamAndResult(MatchHelper.CustomMatcher("abc"))).Returns("123"); 

            Assert.AreEqual(mo.Object.MethodWithParamAndResult("abc"), &ldquo;123);

            Assert.IsNull(mo.Object.MethodWithParamAndResult(&ldquo;newyorktimesbyflex&rdquo;));<br />
        }

public static class MatchHelper<br />
        {<br />
            public static string CustomMatcher(string arg)<br />
            {<br />
                return Match&lt;string&gt;.Create(<br />
                    p =&gt; p.Equals(arg), ()=&gt;null);<br />
            } 

            public static IEnumerable&lt;string&gt; Contains(string key)<br />
            {<br />
                return Match&lt;IEnumerable&lt;string&gt;&gt;.Create(p=&gt;p.Contains(key));<br />
            }<br />
        }
</pre>
</div>
<p>对我们而言CustomMatcher(string arg)和Contains(string key)就是验证方法。和上个例子比较，就是将p =&gt; p.MethodWithParamAndResult(&hellip;&hellip;)里面的东西换成了我们自己的方法。另外一个Contains方法是可用来满足这样一个需求：给定的参数为可迭代类型，只有包含特定的元素时才能匹配</p>
<hr />
<p><strong>Raise</strong></p>
<p>如果你说会用Setup，那么Raise就更简单了。这里注意下它是无返回值类型。</p>
<p>mockView.Raise(v =&gt; v.SelectionChanged += null, new OrderEventArgs { Order = new Order("moq", 500) });</p>
<p><strong>Callback</strong></p>
<p>Callback嘛，顾名思义就是回调。使用Callback可以使我们在某个使用特定参数匹配的方法在被调用时得到通知。比如我们要得知在一次测试中某个方法被调用了几次，可以这么做：</p>
<div>
<pre class="prettyprint linenums">[TestMethod]<br />
        public void MoqTest2()<br />
        {<br />
            var mo = new Mock&lt;TargetInterfaceOne&gt;();<br />
            int counter = 0;<br />
            mo.Setup(p =&gt; p.MethodPure()).Callback( () =&gt; counter++ ); 

            mo.Object.MethodPure();<br />
            mo.Object.MethodPure(); 

            Assert.AreEqual(2, counter);<br />
        }
</pre>
</div>
<p>在这段代码中我们在Setup方法后接了个Callback方法（或者说是调用了ISetup的Callabck方法实现）。这段代码的意思就是在调用MethodPure方法时会执行Callback中的Action委托。</p>
<p>调用两次MethodPure()，测试结果证明确实累加了两次counter。</p>
<p><strong>Verify</strong></p>
<p>有些时候我们并不关注方法的返回结果，而是关注某个方法是不是在内部被调用。</p>
<p>这时我们就用到了Verify/VerifyAll。同时有个有用的类型Times，规定应该调用多少次。如果验证失败则抛出异常。</p>
<div>
<pre class="prettyprint linenums">[TestMethod()] 

public void MoqTest3()<br />
{<br />
    var mo = new Mock&lt;TargetInterfaceOne&gt;();<br />
    mo.Setup( p =&gt; p.MethodPure() );<br />
    mo.Setup( p =&gt; p.MethodWithParam("123")).Verifiable("it should be invoked");<br />
    //mo.Object.MethodPure();<br />
    mo.Object.MethodWithParam("123");<br />
    mo.Verify( p =&gt; p.MethodPure(), Times.AtLeastOnce() );<br />
    mo.Verify(p =&gt; p.MethodWithParam("thto"), Times.AtLeastOnce(),<br />
        "this method  invoking of MethodWithParam() with the parameter: \"thto\" is not happened"); 

    mo.Object.MethodPure();<br />
}
</pre>
</div>
<p>如果在MethodPure前调用mo.Verify(p =&gt; p.MethodPure())则会抛出异常，因为不符合条件：在执行verify前至少调用一次。</p>
<p><strong>关于Verify和VerifyAll</strong></p>
<p>这两个方法会对Mock对象的所有Setup过的方法进行验证，那么有什么不同呢？注意到上面代码中绿色字体部分，有一个Verifiable方法，可以理解为为这个Setup的东西加了个验证标记。而Setup(p=&gt;p.MethodPure())时就没有些，那么我们在使用调用Verify()时只会对MethodWithParam(&ldquo;123&rdquo;)进行验证而不会对MethodPure()是否被调用过进行验证。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o33l8z.html">TDD原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdkr7x9.html">python基础知识2&mdash;&mdash;基本的数据类型&mdash;&mdash;整型，长整型，浮点型，字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e33exq.html">转发！HTML 复选框 checkbox 的 JavaScript 的全选和全反选</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykepm9.html">LeetCode-95&period; Unique Binary Search Trees II</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm4nrl9.html">CSS定位规则之BFC  你居然一直不知道的东西！！！！！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7my08.html">《Algorithms 4th Edition》读书笔记&mdash;&mdash;2&period;4 优先队列&lpar;priority queue&rpar;-Ⅳ</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj0n4k9.html">iOS 中的正则匹配&lpar;工具类方法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7w5oq.html">N沟道和P沟道MOS FET开关电路</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn0lg9.html">Vuex给我们的&period;vue文件结构带来了这些变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z0oz19.html">深入理解计算机系统（4&period;1）------Y86指令集体系结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yrl3r8.html">ELK学习总结（4-2）关于导入数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xp3j9.html">cryptopunks测试代码cryptopunksmarket-setinitial&period;js</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw22vz9.html">BackgroundWorker Class Sample for Beginners</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pxpdw8.html">9：&commat;RequestMapping 用法详解之地址映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koe3o7q.html">JDBC的DAO设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k7yowq.html">利用QtGraphicalEffects来使得自己的图像显示更加生动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd1y7oq.html">vue和jQuery的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jwlwz8.html">crontab 切割日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xy22x9.html">bzoj1264 &lbrack;AHOI2006&rsqb;基因匹配</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0r2lzq.html">linux保留旧版本python，安装python3</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90vwddj8.html">mysql基础示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o67m49.html">Asp&period;net 获取服务器指定文件夹目录文件，并提供下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde6dv09.html">转&vert;in、exists、join效率</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj1x749.html">匹配图片src正则</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvg0goq.html">如何为你的美术妹子做Unity的小工具（三）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vwpz38.html">IIS发布网站：CS0016&colon; 未能写入输出文件的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vwy7o8.html">Java学习之网络编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0ylmgq.html">request&period;getParameter中文乱码问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1rg5k8.html">Android学习笔记（不定时更新）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okx3359.html">php中的require-once</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
